#!/bin/sh

APACHE_TOMCAT_PID_FILE="/tmp/apache-tomcat.pid"

#receives uptime in the format dd-hh:mm:ss and calculates the number of seconds
function calculate_uptime_s(){
uptime=$1

if [ -n $uptime ]; then

    uptime_sec="0"
    uptime_min="0"
    uptime_hours="0"
    uptime_days="0"

    uptime_sec=`echo "$uptime"|rev|cut -d ":" -f1|rev`

    if [ -n "`echo "$uptime"|cut -sd ":" -f2`" ]; then
        uptime_min=`echo $uptime|rev|cut -sd ":" -f2|rev`
        if [ -n "`echo "$uptime"|rev|cut -sd ":" -f3`" ]; then    
            if [ -n "`echo "$uptime"|cut -sd "-" -f2`" ]; then
                uptime_hours=`echo "$uptime"|rev|cut -sd ":" -f3|cut -d "-" -f1|rev`
                uptime_days=`echo "$uptime"|rev|cut -sd ":" -f3|cut -d "-" -f2|rev`
            else
                uptime_hours=`echo "$uptime"|rev|cut -sd ":" -f3|rev`
            fi
        fi
    fi

    #this is to remove eventual leading 0 before doing an aritmentic operation
    #if any value is in the form "08" without this part it will be interpreted as octal

    uptime_sec=`echo $((10#$uptime_sec))`
    uptime_min=`echo $((10#$uptime_min))`
    uptime_hours=`echo $((10#$uptime_hours))`
    uptime_days=`echo $((10#$uptime_days))` 

    uptime_s=$(($uptime_sec+($uptime_min+((($uptime_days*24)+$uptime_hours)*60))*60))
    echo "$uptime_s"
fi
}

#receives a pid and gets the uptime for said pid
function get_uptime4pid()
{

pid=$1
if [ -n pid ]; then
    uptime=`ps --no-headers -o etime $pid|head -1|awk '{$1=$1};1'`
    echo $uptime
fi

echo ""
}

if [ -f $APACHE_TOMCAT_PID_FILE ];
then
    TOMCAT_PID=$(<$APACHE_TOMCAT_PID_FILE)
    uptime=`get_uptime4pid $TOMCAT_PID`
    uptime_s=`calculate_uptime_s $uptime`
    echo $uptime_s
else
    echo "0"
fi
